;***********************************************************************
.data
ALIGN 16
            table db "000102030405060708090A0B0C0D0E0F"
                  db "101112131415161718191A1B1C1D1E1F"
                  db "202122232425262728292A2B2C2D2E2F"
                  db "303132333435363738393A3B3C3D3E3F"
                  db "404142434445464748494A4B4C4D4E4F"
                  db "505152535455565758595A5B5C5D5E5F"
                  db "606162636465666768696A6B6C6D6E6F"
                  db "707172737475767778797A7B7C7D7E7F"
                  db "808182838485868788898A8B8C8D8E8F"
                  db "909192939495969798999A9B9C9D9E9F"
                  db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
                  db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
                  db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
                  db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
                  db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
                  db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"
    console_title db "Mathematical stuff", 0
       szFactCapt db "Large Factorials", 0
       Test_Value dd 0
;-----------------------------------------------------------
; dedndave's model
;   cnr0          dd   16           ; number of dwords in unm0 - Keep very large
;   cnr1          dd   16           ; number of dwords in unm1 - Start at 1 then max n value = 4 Gig - even thou we limit to 20000
;   unm0          dd   16 dup (0)   ; Variable 1
;   unm1          dd   16 dup (0)   ; Variable 2
;   unm2          dd   32 dup (0)   ; Carry Table
;   unm3          dd   32 dup (0)   ; Multiplication Result
;-----------------------------------------------------------
; when cnr0 is    16 then max n value =    512 bits =    64 byte capability
; when cnr0 is    32 then max n value =   1024 bits =   128
; when cnr0 is    64 then max n value =   2048 bits =   256
; when cnr0 is   128 then max n value =   4096 bits =   512
; when cnr0 is   256 then max n value =   8192 bits =  1024
; when cnr0 is   512 then max n value =  16384 bits =  2048
; when cnr0 is  1024 then max n value =  32768 bits =  4096
; when cnr0 is  2048 then max n value =  64536 bits =  8192
; when cnr0 is  4096 then max n value = 129072 bits = 16384
; when cnr0 is  8192 then max n value = 258144 bits = 32768  if n = 20000 then we need this configuration
; when cnr0 is 16384 then max n value = 516288 bits = 64536
;-----------------------------------------------------------
;   cnr0          dd  128           ; number of dwords in unm0 - Keep very large
;   unm0          dd  128 dup (0)   ; Variable 1
;   cnr1          dd    2           ; number of dwords in unm1 - Start at 1 then max n value = 4 Gig - even thou we limit to 20000
;   unm1          dd    2 dup (0)   ; Variable 2
;   unm2          dd  256 dup (0)   ; Carry Table
;   unm3          dd  256 dup (0)   ; Multiplication Result

    cnr0          dd  8192           ; number of dwords in unm0 - Keep very large
    unm0          dd  8192 dup (0)   ; Variable 1
    cnr1          dd     2           ; number of dwords in unm1 - Start at 1 then max n value = 4 Gig - even thou we limit to 20000
    unm1          dd     2 dup (0)   ; Variable 2
    unm2          dd 16384 dup (0)   ; Carry Table
    unm3          dd 16384 dup (0)   ; Multiplication Result

    unm10          dd  8192 dup (0)   ; Variable 1 - For Combinations
    unm11          dd  8192 dup (0)   ; Variable 2 - For Combinations

;-----------------------------------------------------------
LLKF_Str          db 8192 dup (0)
LLKF_Safety       db   32 dup (0)
  h_file          dd    0
    cnt_pos       db   32 dup (0)
;***********************************************************************
.data?
    SMALL_RECT STRUCT
        Left      WORD      ?
        Top       WORD      ?
        Right     WORD      ?
        Bottom    WORD      ?
    SMALL_RECT ENDS
    max_coord       COORD <>
    small_rect      SMALL_RECT <>
    csbi            CONSOLE_SCREEN_BUFFER_INFO <>
    cci             CONSOLE_CURSOR_INFO <>
    ; -----------------------------------------------------------------
    hConsoleOutput  dd ?                ; console output handle
    rowpos          db ?                ; row position
    colpos          db ?                ; column position
    currowpos       db ?                ; cursor row position
    curcolpos       db ?                ; cursor col position
    editpos         db ?                ; saved column position for editing
    count           dd ?
    infmt           db ?
    n_val           dd ?
    r_val           dd ?
    
;************************************************************************
.const
    black         equ 0
    blue          equ 1
    green         equ 2
    cyan          equ 3
    red           equ 4
    magenta       equ 5
    brown         equ 6
    white         equ 7
    grey          equ 8
    light_blue    equ 9
    light_green   equ 10
    light_cyan    equ 11
    light_red     equ 12
    light_magenta equ 13
    yellow        equ 14
    bright_white  equ 15
;************************************************************************
