; 
My_Factorial proc
    push eax
    push ebx
    push ecx
    push edx
         cls
         My_Display_Data  2,  2,   light_cyan, 0, "Factorials"
         My_Display_Data  8,  4,         cyan, 0, "This demo computes a Factorial(n) function where           "
         My_Display_Data  8,  5,         cyan, 0, "n values can reach up to 20,000.  For small n values such  "
         My_Display_Data  8,  6,         cyan, 0, "as 150, zero fill leading zero digits.                     "
         My_Display_Data 25,  8,  light_green, 0, "1"
         My_Display_Data 25, 10,  light_green, 0, "2"
         My_Display_Data 27,  8,        brown, 0, "- Compute Factorial"
         My_Display_Data 27, 10,        brown, 0, "- Edit n value"
         My_Display_Data 20, 23, bright_white, 0, "Enter Menu Number or Press Esc to Exit"
         mov eax,  150                            ; set default n value
         mov n_val, eax                           ; store it for use
         invoke My_Display_F_Val                  ; now display it
     Fact_keypress:
         getkey                                   ; wait for & get keypress
         SWITCH eax
         case 27                                  ; is it Esc?
              jmp Fact_Esc_Exit
         case "1"
              invoke Calc_Factorial               ; Calculate the factorial
              invoke Display_Fact_Results         ; The Factorial is done, so display the results
              invoke Output_Factorial             ; Save to disk as fact.txt
              invoke Test_unm3                    ; Determines how many dd's have been filled versus max size
         case "2"
              invoke My_Edit_F_Val
         DEFAULT
              jmp Fact_keypress
         ENDSW
         jmp Fact_keypress
     Fact_Esc_Exit:
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
My_Factorial endp
; 
My_Display_F_Val proc
LOCAL n_temp :DWORD
    push eax
    push ebx
    push ecx
    push edx
         My_Display_Data 10, 14, black, black, "                                                                      "
         My_Display_Data 10, 12, light_cyan, 0, "n value = "
         mov eax, n_val                                       ; Get n_val
         test eax, eax                                        ; Set flags
         jnbe n_val_ok                                        ; Is n_val = zero ?
         mov eax, 1                                                ; yes - set n_val to 1, we don't want zero
         mov n_val, eax
     n_val_ok:
         invoke locate, 22, 12                                ; Set screen location for printing
         mov eax, n_val
         mov n_temp, eax                                      ; Store n value in scratch variable
         mov ecx, 10000                                       ; Setup for ten-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 23, 12                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         mov ecx, 1000                                        ; Setup for one-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 24, 12                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         mov ecx, 100                                         ; Setup for hundreds digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 25, 12                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         mov ecx, 10                                          ; Ten-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 26, 12                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
My_Display_F_Val endp
; 
My_Edit_F_Val proc
LOCAL n_temp :DWORD
LOCAL n_col  :DWORD
LOCAL n_row  :DWORD
LOCAL n_char :DWORD
    push eax
    push ebx
    push ecx
    push edx
         My_Display_Data  1, 17, black, black, "                                                                      "
         My_Display_Data 10, 20, black, black, "                                                                      "
         My_Display_Data 10, 23, black, black, "                                                                      "
         My_Display_Data 10, 14, black, black, "                                                                      "
         My_Display_Data 20, 14, white, 0, "Enter n value or Press Esc to Exit              "
         mov eax, 22
         mov n_col, eax
         mov eax, 12
         mov n_row, eax
         sub eax, eax
         mov n_temp, eax
         sub ebx, ebx
         invoke MySetTextColor, yellow, black
         invoke MyShowCursor
         .repeat
     pos_it:
             invoke locate, n_col, n_row       ; Set screen location for printing
             xor eax, eax                      ; For safety
             getkey                            ; wait for & get keypress
             .if eax == 27                     ; Was Esc key was pressed?
                 jmp Edit_Esc_Exit                   ; Yes - Exit
             .endif
             .if eax >= 48 && eax <= 57        ; Was key a nummeric key?
                 sub eax, 48                   ; ASCII to Binary Adjustment
                 .if n_col == 22
                     mov ecx, 10000
                 .endif
                 .if n_col == 23
                     mov ecx, 1000
                 .endif
                 .if n_col == 24
                     mov ecx, 100
                 .endif
                 .if n_col == 25
                     mov ecx, 10
                 .endif
                 .if n_col == 26
                     mov ecx, 1
                 .endif
                 xor edx, edx                  ; For safety
                 mul ecx                       ; multiply inputed value by units value
                 add ebx, eax                  ; Accumulate result as we go
                 mov n_char, eax               ; temp save inputed key
                 invoke locate, n_col, n_row   ; Set screen location for printing
                 print ustr$(n_char)           ; Ok print inputed key
                 mov eax, n_col                ; Get col position
                 inc eax                       ; Increment it
                 mov n_col, eax                ; Save it
             .else
                 jmp pos_it                    ; We only want numeric digits
             .endif
         .until n_col >= 27
         mov n_temp, ebx                       ; Temp save inputed value
     Edit_Esc_Exit:
         mov eax, n_temp                       ; Get temp inputed value
         .if eax == 0                          ; Is value = zero
             mov eax, 1                             ; Yes - make it One, we don't want zero
         .endif
         mov n_val, eax                        ; Store result in n_val
         invoke MyHideCursor                   ; Turn Cursor off
         invoke My_Display_F_Val               ; Redisplay new n value
         My_Display_Data 20, 14, black, 0, "                                                "
         My_Display_Data 20, 23, white, 0, "Enter Menu Number or Press Esc to Exit"
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
My_Edit_F_Val endp
; 
Calc_Factorial proc
LOCAL n_temp :DWORD
LOCAL n_pos :DWORD
    push eax
    push ebx
    push ecx
    push edx
         xor eax, eax                        ; Clear accum
         mov n_pos, eax                      ; Set to zero
         My_Display_Data 20, 14, black, 0, "                                                " ; Start with a blank slate
;         mov eax, n_val                      ; Get n_val
;         cmp eax, 20001                      ; Is it in range?
;         jb process_n_val                       ; Yes - Process Factorial
                                                ; No - Provide error message
;         My_Display_Data 20, 14, yellow, 0, "n value is out of range (max value = 20000)"
;         jmp Calc_Factorial_Exit
     process_n_val:
         mov eax, n_val                      ; Get n value
         invoke Reset_unm1, eax              ; Reset unm1 and set to n value
         dec eax                             ; We don't wan't to square here, we need n = n-1
         mov n_temp, eax                     ; Put in scratch variable
         invoke Reset_unm0, eax              ; Reset unm1 and set to n-1 value
         invoke Reset_unm2                   ; Reset unm2
         invoke Reset_unm3                   ; Reset unm3
         invoke Multiply_It                  ; Multiply the two factors
     next_factor:
         mov eax, n_temp                     ; Get last saved value
         dec eax                             ; n = n-1
         mov n_temp, eax                     ; Put in scratch variable
         test eax, eax                       ; Is n = 0
         jz Calc_Factorial_Exit                 ; Yes - we are done
         invoke Reset_unm1, eax              ; No - Reset unm1 and set to n-1 value
         invoke Move_unm3_to_unm0            ; Transfer computed value back to unm0
         invoke Reset_unm2                   ; For safety
         invoke Reset_unm3                   ; For safety
         invoke Multiply_It                  ; Multiply the two factors
         jmp next_factor
     Calc_Factorial_Exit:
         invoke Count_Pos, ADDR n_pos        ; Counts how many DD's have been used in unm3 - Overflow testing during design
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Calc_Factorial endp
; 
Reset_unm0 proc set_val :DWORD
    push eax
    push ebx
    push ecx
         mov eax, set_val                             ; initialization value
         mov ebx, 0                                   ; reset position pointer
         mov ecx, 0                                   ; zero
         .repeat
             .if ebx == 0
                 mov [unm0 + ebx * 4], eax            ; set data-grouping to n_val
             .else
                 mov [unm0 + ebx * 4], ecx            ; set data-grouping to zero
             .endif
             inc ebx                                  ; increment unm0 position pointer
         .until ebx >= cnr0                           ; cnr0 is the number of dd's in unm0, repeat if not done with all dd's
    pop ecx
    pop ebx
    pop eax
    ret
Reset_unm0 endp
; 
Reset_unm1 proc set_val :DWORD
    push eax
    push ebx
    push ecx
         mov eax, set_val                             ; initialization value
         mov ebx, 0                                   ; reset position pointer
         mov ecx, 0                                   ; zero
         .repeat
             .if ebx == 0
                 mov [unm1 + ebx * 4], eax            ; set data-grouping to n_val
             .else
                 mov [unm1 + ebx * 4], ecx            ; set data-grouping to zero
             .endif
             inc ebx                                  ; increment unm1 position pointer
         .until ebx >= cnr1                           ; cnr1 is the number of dd's in unm1, repeat if not done with all dd's
    pop ecx
    pop ebx
    pop eax
    ret
Reset_unm1 endp
; 
Reset_unm2 proc
    push eax
    push ebx
    push ecx
         mov eax, cnr0                                ; Get quantity of dd's for unm0
         shl eax, 1                                   ; Double it to match multiplication rule
         mov ebx, 0                                   ; reset position pointer
         mov ecx, 0                                   ; zero
         .repeat
             mov [unm2 + ebx * 4], ecx                ; set data-grouping to zero
             inc ebx                                  ; increment unm2 position pointer
         .until ebx >= eax                            ; eax is the number of dd's in unm2, repeat if not done with all dd's
    pop ecx
    pop ebx
    pop eax
    ret
Reset_unm2 endp
; 
Reset_unm3 proc
    push eax
    push ebx
    push ecx
         mov eax, cnr0                                ; Get quantity of dd's for unm0
         shl eax, 1                                   ; Double it to match multiplication rule
         mov ebx, 0                                   ; reset position pointer
         mov ecx, 0                                   ; zero
         .repeat
             mov [unm3 + ebx * 4], ecx                ; set data-grouping to zero
             inc ebx                                  ; increment unm3 position pointer
         .until ebx >= eax                            ; eax is the number of dd's in unm3, repeat if not done with all dd's
    pop ecx
    pop ebx
    pop eax
    ret
Reset_unm3 endp
; 
Multiply_It proc
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         ; -------------------------------------------------------------------------
         ;               Multiply unm0 and unm1 and place result in unm3 and let unm2 handle the carries
         ; -------------------------------------------------------------------------
         mov ebx, 0                                   ; reset position pointer
         mov esi, 0                                   ; reset position pointer
         mov edi, 0                                   ; reset position pointer
         .repeat
             mov ecx, [unm0 + ebx * 4]                ; get dd data-grouping from unm0, pointed to by ebx
             .if ecx != 0                             ; skip multiply of row if multiplying by 0
                 .repeat
                     mov eax, [unm1 + esi * 4]        ; get dd data-grouping from unm1, pointed to by esi
                     mul ecx                          ; multiply unm1[esi]-grouping by unm0[ebx]-grouping
                     add [unm3 + edi * 4 + 0], eax    ; put the result into unm3 with addition process, keeping old value plus new value
                     adc [unm3 + edi * 4 + 4], edx    ; put the result into unm3 with addition process, keeping old value plus new value, with carry
                     adc [unm2 + edi * 4 + 8], 0      ; in case carry propagates store in carry holder, add in later
                     inc edi                          ; increment unm2 and unm3 position pointer
                     inc esi                          ; increment unm1 position pointer
                 .until esi >= cnr1                   ; cnr1 is the number of dd's in unm1, repeat if not done with all dd's
             .endif
             mov esi, 0                               ; reset counter
             inc ebx                                  ; increment unm0 position pointer
             mov edi, ebx                             ; save to pointer from dd grouping
         .until ebx >= cnr0                           ; cnr0 is the number of dd's in unm0, repeat if not done with all dd's
         ; -------------------------------------------------------------------------
         ;               Process carry's that propagated over during Multiply's
         ; -------------------------------------------------------------------------
         mov ecx, cnr1                                ; get the number of dd's in unm1 (good being defined as how many significant digits unm1 has)
         add ecx, cnr0                                ; add the number of dd's in unm0 - adding significant digits creates total digits for output
         xor eax, eax                                 ; reset
         xor edi, edi                                 ; set appropriate flags
         clc                                          ; not needed  carry value from bit 0 of eax, which was set to 0
         .repeat
             bt eax, 0                                ; needed to restore carry because the .until modifies it
             mov edx, [unm2 + edi * 4 ]               ; Get value from unm2[edi]
             adc [unm3 + edi * 4], edx                ; Add one more if carry was previously set and put result into unm3[edi]
             setc al                                  ; save carry for next iteration of the .repeat loop
             inc edi                                  ; increment position pointer
         .until edi >= ecx
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Multiply_It endp
; 
Move_unm3_to_unm0 proc
    push eax
    push ebx
    push ecx
         mov ebx, 0                            ; reset position pointer
         .repeat
             mov eax, [unm3 + ebx * 4]         ; get data-grouping
             mov [unm0 + ebx * 4], eax         ; set data-grouping
             inc ebx                           ; increment unm0 position pointer
         .until ebx >= cnr0                    ; cnr0 is the number of dd's in unm0, repeat if not done with all dd's
    pop ecx
    pop ebx
    pop eax
    ret
Move_unm3_to_unm0 endp
; 
Display_Fact_Results proc
LOCAL n_temp1 :DWORD
LOCAL n_temp2 :DWORD
LOCAL n_temp3 :DWORD

    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         lea edi, LLKF_Str
         mov ecx, SizeOf LLKF_Str
         xor eax, eax
     next_LLKF:
         mov BYTE PTR [edi], al
         inc edi
         dec ecx
         jnz next_LLKF
         Invoke uArb2StrL9, ADDR unm3, 1024, ADDR LLKF_Str, 4096
                mov n_temp1, eax       ; status report
                mov n_temp2, ecx       ; length of LLKF_Str
                mov n_temp3, edx       ; pointer to LLKF_Str begining point

                My_Display_Data 1, 17, red, black, "LLKF status = "
                print ustr$(n_temp1)

         My_Display_Data 10, 14, yellow, black, "n! = "
         mov ebx, n_temp2
         .if n_temp1 == 0
             .if ebx >= 39
                 print "See generated fact.txt file"
             .else
                 .if ebx <= 12
                     print ustr$(unm0)
                 .else
                     mov edx, n_temp3
                     print edx
                 .endif
             .endif
         .endif    
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Display_Fact_Results endp
; 
Output_Factorial proc
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         mov h_file, fcreate("Fact.txt")
         mov ebx, len(ADDR LLKF_Str)
         mov ebx, fwrite(h_file, ADDR LLKF_Str, ebx)
         fclose h_file
         mov h_file, fcreate("Pos.txt")
         mov ebx, 256
         mov ebx, fwrite(h_file, ADDR cnt_pos, ebx)
         fclose h_file
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Output_Factorial endp
; 
Count_Pos proc ptr_pos :DWORD
LOCAL n_cnt0 :DWORD
LOCAL n_cnt1 :DWORD
LOCAL n_cnt2 :DWORD
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         mov edx, 0                                   ; initialize to zero
         mov n_cnt0, edx                              ; initialize to zero
         mov n_cnt1, edx                              ; initialize to zero
         mov n_cnt2, edx                              ; initialize to zero
         mov edx, cnr0                                ; get ## of dd's in unm3
         shl edx, 1                                   ; times two
         mov ebx, 0                                   ; reset position pointer
         .repeat
;
;
; all zeros
; all ones
; ones then zeros
; zeros then ones
; zeros then ones then zeros
;
;
             mov ecx, [unm3 + ebx * 4]                ; get dd data-grouping from unm0, pointed to by ebx
             .if ecx == 0 && n_cnt1 == 0              ; Count the LSD's that are zero
                 mov eax, n_cnt0
                 inc eax
                 mov n_cnt0, eax
             .endif
             .if ecx != 0 && n_cnt2 == 0              ; Count the Middle Digits that are not zero
                 mov eax, n_cnt1
                 inc eax
                 mov n_cnt1, eax
             .endif
             .if ecx == 0 && n_cnt1 >= 1              ; Count the MSD's that are zero
                 mov eax, n_cnt2
                 inc eax
                 mov n_cnt2, eax
             .endif
             inc ebx                                  ; increment position pointer
         .until ebx >= edx                            ; edx is the number of dd's to test, repeat if not done with all dd's
         lea edx, cnt_pos                             ; get address
         mov ecx, n_cnt0                              ; get count
         mov [edx], ecx                               ; save count for writing to disk
         add edx, 4                                   ; set to next location
         mov ecx, n_cnt1                              ; get count
         mov [edx], ecx                               ; save count for writing to disk
         add edx, 4                                   ; set to next location
         mov ecx, n_cnt2                              ; get count
         mov [edx], ecx                               ; save count for writing to disk
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Count_Pos endp
; 
Test_unm3 proc
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         loc 10, 20                                  ; reposition after blanking out the data
         print "                                                          "
         loc 10, 20                                  ; reposition after blanking out the data
         lea ebx, cnt_pos                            ; get address of counted dd's that were not used
         mov eax, [ebx]                              ; now get count
         print ustr$(eax)                            ; and print it
         loc 25, 20                                  ; reposition after blanking out the data
         lea ebx, cnt_pos                            ; get address of counted dd's that were not used
         add ebx, 4
         mov eax, [ebx]                              ; now get count
         print ustr$(eax)                            ; and print it
         loc 40, 20                                  ; reposition after blanking out the data
         lea ebx, cnt_pos                            ; get address of counted dd's that were not used
         add ebx, 8
         mov eax, [ebx]                              ; now get count
         print ustr$(eax)                            ; and print it
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Test_unm3 endp
; 
