; 
My_Combination proc
    push eax
    push ebx
    push ecx
    push edx
         cls
         My_Display_Data  2,  2,   light_cyan, 0, "Combinations"
         My_Display_Data  8,  4,         cyan, 0, "This demo computes a Combination(n, r) function where           "
         My_Display_Data  8,  5,         cyan, 0, "n (or r) values can reach up to 150.  For small n values such   "
         My_Display_Data  8,  6,         cyan, 0, "as 150, zero fill leading zero digits.                     "
         My_Display_Data 25,  8,  light_green, 0, "1"
         My_Display_Data 25, 10,  light_green, 0, "2"
         My_Display_Data 25, 12,  light_green, 0, "3"

         My_Display_Data 27,  8,        brown, 0, "- Compute Combination"
         My_Display_Data 27, 10,        brown, 0, "- Edit n value"
         My_Display_Data 27, 12,        brown, 0, "- Edit r value"

         My_Display_Data 20, 23, bright_white, 0, "Enter Menu Number or Press Esc to Exit"
         mov eax,  150                            ; set default n value
         mov n_val, eax                           ; store it for use
         mov eax,  23                             ; set default r value
         mov r_val, eax                           ; store it for use
         invoke My_Display_FR_Val                 ; now display them
     Comb_keypress:
         getkey                                   ; wait for & get keypress
         SWITCH eax
         case 27                                  ; is it Esc?
              jmp Comb_Esc_Exit
         case "1"
              invoke Calc_Combination             ; Calculate the factorial
;              invoke Display_Comb_Results         ; The Factorial is done, so display the results
;              invoke Output_Combination           ; Save to disk as fact.txt
         case "2"
               invoke My_Edit_CN_Val
         case "3"
               invoke My_Edit_CR_Val
         DEFAULT
              jmp Comb_keypress
         ENDSW
         jmp Comb_keypress
     Comb_Esc_Exit:
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
My_Combination endp
; 
My_Display_FR_Val proc
LOCAL n_temp :DWORD
LOCAL r_temp :DWORD
    push eax
    push ebx
    push ecx
    push edx
         My_Display_Data 10, 16, black, black, "                                                                      "
         My_Display_Data 10, 14, light_cyan, 0, "n value = "
         mov eax, n_val                                       ; Get n_val
         test eax, eax                                        ; Set flags
         jnbe n_val_ok                                        ; Is n_val = zero ?
         mov eax, 1                                                ; yes - set n_val to 1, we don't want zero
         mov n_val, eax
     n_val_ok:
         invoke locate, 22, 14                                ; Set screen location for printing
         mov eax, n_val
         mov n_temp, eax                                      ; Store n value in scratch variable
         mov ecx, 10000                                       ; Setup for ten-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 23, 14                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         mov ecx, 1000                                        ; Setup for one-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 24, 14                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         mov ecx, 100                                         ; Setup for hundreds digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 25, 14                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         mov ecx, 10                                          ; Ten-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov n_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 26, 14                                ; Set screen location for printing
         mov eax, n_temp                                      ; setup next value (digit)
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         My_Display_Data 30, 14, light_cyan, 0, "r value = "
         ; ---------------------------
         mov eax, r_val                                       ; Get r_val
         test eax, eax                                        ; Set flags
         jnbe r_val_ok                                        ; Is r_val = zero ?
         mov eax, 1                                                ; yes - set r_val to 1, we don't want zero
         mov r_val, eax
     r_val_ok:
         invoke locate, 42, 14                                ; Set screen location for printing
         mov eax, r_val
         mov r_temp, eax                                      ; Store n value in scratch variable
         mov ecx, 10000                                       ; Setup for ten-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov r_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 43, 14                                ; Set screen location for printing
         mov eax, r_temp                                      ; setup next value (digit)
         mov ecx, 1000                                        ; Setup for one-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov r_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 44, 14                                ; Set screen location for printing
         mov eax, r_temp                                      ; setup next value (digit)
         mov ecx, 100                                         ; Setup for hundreds digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov r_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 45, 14                                ; Set screen location for printing
         mov eax, r_temp                                      ; setup next value (digit)
         mov ecx, 10                                          ; Ten-thousands digit
         xor edx, edx                                         ; just to be safe
         div ecx                                              ; get quotient into eax
         mov r_temp, edx                                      ; put remainder into scratch variable
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
         invoke locate, 46, 14                                ; Set screen location for printing
         mov eax, r_temp                                      ; setup next value (digit)
         print ustr$(eax)                                     ; Display result
         ; ---------------------------
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
My_Display_FR_Val endp
; 
My_Edit_CN_Val proc
LOCAL n_temp :DWORD
LOCAL n_col  :DWORD
LOCAL n_row  :DWORD
LOCAL n_char :DWORD
    push eax
    push ebx
    push ecx
    push edx
         My_Display_Data  1, 17, black, black, "                                                                      "
         My_Display_Data 10, 20, black, black, "                                                                      "
         My_Display_Data 10, 23, black, black, "                                                                      "
         My_Display_Data 10, 16, black, black, "                                                                      "
         My_Display_Data 20, 16, white, 0, "Enter n value or Press Esc to Exit              "
         mov eax, 22
         mov n_col, eax
         mov eax, 14
         mov n_row, eax
         sub eax, eax
         mov n_temp, eax
         sub ebx, ebx
         invoke MySetTextColor, yellow, black
         invoke MyShowCursor
         .repeat
     pos_it:
             invoke locate, n_col, n_row       ; Set screen location for printing
             xor eax, eax                      ; For safety
             getkey                            ; wait for & get keypress
             .if eax == 27                     ; Was Esc key was pressed?
                 jmp Edit_Esc_Exit                   ; Yes - Exit
             .endif
             .if eax >= 48 && eax <= 57        ; Was key a nummeric key?
                 sub eax, 48                   ; ASCII to Binary Adjustment
                 .if n_col == 22
                     mov ecx, 10000
                 .endif
                 .if n_col == 23
                     mov ecx, 1000
                 .endif
                 .if n_col == 24
                     mov ecx, 100
                 .endif
                 .if n_col == 25
                     mov ecx, 10
                 .endif
                 .if n_col == 26
                     mov ecx, 1
                 .endif
                 xor edx, edx                  ; For safety
                 mul ecx                       ; multiply inputed value by units value
                 add ebx, eax                  ; Accumulate result as we go
                 mov n_char, eax               ; temp save inputed key
                 invoke locate, n_col, n_row   ; Set screen location for printing
                 print ustr$(n_char)           ; Ok print inputed key
                 mov eax, n_col                ; Get col position
                 inc eax                       ; Increment it
                 mov n_col, eax                ; Save it
             .else
                 jmp pos_it                    ; We only want numeric digits
             .endif
         .until n_col >= 27
         mov n_temp, ebx                       ; Temp save inputed value
     Edit_Esc_Exit:
         mov eax, n_temp                       ; Get temp inputed value
         .if eax == 0                          ; Is value = zero
             mov eax, 1                             ; Yes - make it One, we don't want zero
         .endif
         mov n_val, eax                        ; Store result in n_val
         invoke MyHideCursor                   ; Turn Cursor off
         invoke My_Display_FR_Val               ; Redisplay new n value
         My_Display_Data 20, 16, black, 0, "                                                "
         My_Display_Data 20, 23, white, 0, "Enter Menu Number or Press Esc to Exit"
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
My_Edit_CN_Val endp
; 
My_Edit_CR_Val proc
LOCAL r_temp :DWORD
LOCAL n_col  :DWORD
LOCAL n_row  :DWORD
LOCAL n_char :DWORD
    push eax
    push ebx
    push ecx
    push edx
         My_Display_Data  1, 17, black, black, "                                                                      "
         My_Display_Data 10, 20, black, black, "                                                                      "
         My_Display_Data 10, 23, black, black, "                                                                      "
         My_Display_Data 10, 16, black, black, "                                                                      "
         My_Display_Data 20, 16, white, 0, "Enter r value or Press Esc to Exit              "
         mov eax, 42
         mov n_col, eax
         mov eax, 14
         mov n_row, eax
         sub eax, eax
         mov r_temp, eax
         sub ebx, ebx
         invoke MySetTextColor, yellow, black
         invoke MyShowCursor
         .repeat
     pos_it:
             invoke locate, n_col, n_row       ; Set screen location for printing
             xor eax, eax                      ; For safety
             getkey                            ; wait for & get keypress
             .if eax == 27                     ; Was Esc key was pressed?
                 jmp Edit_Esc_Exit                   ; Yes - Exit
             .endif
             .if eax >= 48 && eax <= 57        ; Was key a nummeric key?
                 sub eax, 48                   ; ASCII to Binary Adjustment
                 .if n_col == 42
                     mov ecx, 10000
                 .endif
                 .if n_col == 43
                     mov ecx, 1000
                 .endif
                 .if n_col == 44
                     mov ecx, 100
                 .endif
                 .if n_col == 45
                     mov ecx, 10
                 .endif
                 .if n_col == 46
                     mov ecx, 1
                 .endif
                 xor edx, edx                  ; For safety
                 mul ecx                       ; multiply inputed value by units value
                 add ebx, eax                  ; Accumulate result as we go
                 mov n_char, eax               ; temp save inputed key
                 invoke locate, n_col, n_row   ; Set screen location for printing
                 print ustr$(n_char)           ; Ok print inputed key
                 mov eax, n_col                ; Get col position
                 inc eax                       ; Increment it
                 mov n_col, eax                ; Save it
             .else
                 jmp pos_it                    ; We only want numeric digits
             .endif
         .until n_col >= 47
         mov r_temp, ebx                       ; Temp save inputed value
     Edit_Esc_Exit:
         mov eax, r_temp                       ; Get temp inputed value
         .if eax == 0                          ; Is value = zero
             mov eax, 1                             ; Yes - make it One, we don't want zero
         .endif
         mov r_val, eax                        ; Store result in n_val
         invoke MyHideCursor                   ; Turn Cursor off
         invoke My_Display_FR_Val               ; Redisplay new n value
         My_Display_Data 20, 16, black, 0, "                                                "
         My_Display_Data 20, 23, white, 0, "Enter Menu Number or Press Esc to Exit"
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
My_Edit_CR_Val endp
; 
Calc_Combination proc
LOCAL n_temp :DWORD
LOCAL r_temp :DWORD
LOCAL n_pos :DWORD
    push eax
    push ebx
    push ecx
    push edx
         xor eax, eax                        ; Clear accum
         mov n_pos, eax                      ; Set to zero
         My_Display_Data 20, 16, black, 0, "                                                " ; Start with a blank slate
         mov eax, n_val                      ; Get n_val
         cmp eax, 200                        ; Is it in range?
         jb process_n_val                       ; Yes - Process Factorial
                                                ; No - Provide error message
         My_Display_Data 20, 16, yellow, 0, "n value is out of range (max value = 200)"
         jmp Calc_Combination_Exit
     process_n_val:
         mov eax, n_val                      ; Get n value
         invoke Reset_unm1, eax              ; Reset unm1 and set to n value
         dec eax                             ; We don't wan't to square here, we need n = n-1
         mov n_temp, eax                     ; Put in scratch variable
         invoke Reset_unm0, eax              ; Reset unm1 and set to n-1 value
         invoke Reset_unm2                   ; Reset unm2
         invoke Reset_unm3                   ; Reset unm3
         invoke Multiply_It                  ; Multiply the two factors
     next_n_factor:
         mov eax, n_temp                     ; Get last saved value
         dec eax                             ; n = n-1
         mov n_temp, eax                     ; Put in scratch variable
         test eax, eax                       ; Is n = 0
         jz Calc_N_Exit                           ; Yes - we are done
         invoke Reset_unm1, eax              ; No - Reset unm1 and set to n-1 value
         invoke Move_unm3_to_unm0            ; Transfer computed value back to unm0
         invoke Reset_unm2                   ; For safety
         invoke Reset_unm3                   ; For safety
         invoke Multiply_It                  ; Multiply the two factors
         jmp next_n_factor
     Calc_N_Exit:
         invoke Move_unm3_to_unm10           ; Save to numerator position
         xor eax, eax                        ; Clear accum
         mov n_pos, eax                      ; Set to zero
         My_Display_Data 20, 16, black, 0, "                                                " ; Start with a blank slate
         mov eax, r_val                      ; Get n_val
         cmp eax, 200                        ; Is it in range?
         jb process_r_val                       ; Yes - Process Factorial
                                                ; No - Provide error message
         My_Display_Data 20, 16, yellow, 0, "r value is out of range (max value = 200)"
         jmp Calc_Combination_Exit
     process_r_val:
         mov eax, r_val                      ; Get n value
         invoke Reset_unm1, eax              ; Reset unm1 and set to n value
         dec eax                             ; We don't wan't to square here, we need n = n-1
         mov r_temp, eax                     ; Put in scratch variable
         invoke Reset_unm0, eax              ; Reset unm1 and set to n-1 value
         invoke Reset_unm2                   ; Reset unm2
         invoke Reset_unm3                   ; Reset unm3
         invoke Multiply_It                  ; Multiply the two factors
     next_r_factor:
         mov eax, r_temp                     ; Get last saved value
         dec eax                             ; n = n-1
         mov r_temp, eax                     ; Put in scratch variable
         test eax, eax                       ; Is n = 0
         jz Calc_R_Exit                           ; Yes - we are done
         invoke Reset_unm1, eax              ; No - Reset unm1 and set to n-1 value
         invoke Move_unm3_to_unm0            ; Transfer computed value back to unm0
         invoke Reset_unm2                   ; For safety
         invoke Reset_unm3                   ; For safety
         invoke Multiply_It                  ; Multiply the two factors
         jmp next_r_factor
     Calc_R_Exit:
         invoke Move_unm3_to_unm11           ; Save to denominator position
         My_Display_Data 5, 18,  light_green, 0, "At this point you must divide unm10 by unm11 and put into LLFK"
;        invoke Divide_It
     Calc_Combination_Exit:
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Calc_Combination endp
; 
Display_Comb_Results proc
LOCAL n_temp1 :DWORD
LOCAL n_temp2 :DWORD
LOCAL n_temp3 :DWORD

    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         lea edi, LLKF_Str
         mov ecx, SizeOf LLKF_Str
         xor eax, eax
     next_LLKF:
         mov BYTE PTR [edi], al
         inc edi
         dec ecx
         jnz next_LLKF
         Invoke uArb2StrL9, ADDR unm3, 1024, ADDR LLKF_Str, 4096
                mov n_temp1, eax       ; status report
                mov n_temp2, ecx       ; length of LLKF_Str
                mov n_temp3, edx       ; pointer to LLKF_Str begining point

                My_Display_Data 1, 17, red, black, "LLKF status = "
                print ustr$(n_temp1)

         My_Display_Data 10, 16, yellow, black, "nCr = "
         mov ebx, n_temp2
         .if n_temp1 == 0
             .if ebx >= 39
                 print "See generated Comb.txt file"
             .else
                 .if ebx <= 12
                     print ustr$(unm0)
                 .else
                     mov edx, n_temp3
                     print edx
                 .endif
             .endif
         .endif    

    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Display_Comb_Results endp
; 
Output_Combination proc
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         mov h_file, fcreate("Comb.txt")
         mov ebx, len(ADDR LLKF_Str)
         mov ebx, fwrite(h_file, ADDR LLKF_Str, ebx)
         fclose h_file
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Output_Combination endp
; 
Move_unm3_to_unm10 proc
    push eax
    push ebx
    push ecx
         mov ebx, 0                            ; reset position pointer
         .repeat
             mov eax, [unm3 + ebx * 4]         ; get data-grouping
             mov [unm10 + ebx * 4], eax        ; set data-grouping
             inc ebx                           ; increment unm0 position pointer
         .until ebx >= cnr0                    ; cnr0 is the number of dd's in unm0, repeat if not done with all dd's
    pop ecx
    pop ebx
    pop eax
    ret
Move_unm3_to_unm10 endp
; 
Move_unm3_to_unm11 proc
    push eax
    push ebx
    push ecx
         mov ebx, 0                            ; reset position pointer
         .repeat
             mov eax, [unm3 + ebx * 4]         ; get data-grouping
             mov [unm11 + ebx * 4], eax        ; set data-grouping
             inc ebx                           ; increment unm0 position pointer
         .until ebx >= cnr0                    ; cnr0 is the number of dd's in unm0, repeat if not done with all dd's
    pop ecx
    pop ebx
    pop eax
    ret
Move_unm3_to_unm11 endp
; 
Divide_It proc
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         ; -------------------------------------------------------------------------
         ;               Divide unm10 by unm11 and place result in unm3 and let unm2 handle the carries/borrows
         ; -------------------------------------------------------------------------
         mov ebx, 0                                   ; reset position pointer
         mov esi, 0                                   ; reset position pointer
         mov edi, 0                                   ; reset position pointer
         .repeat
             mov ecx, [unm11 + ebx * 4]               ; get dd data-grouping from unm11, pointed to by ebx
             .if ecx != 0                             ; skip divide of row if by 0
                 .repeat
                     mov eax, [unm10 + esi * 4]       ; get dd data-grouping from unm10, pointed to by esi
                     div ecx                          ; divide unm11[esi]-grouping by unm10[ebx]-grouping



                     add [unm3 + edi * 4 + 0], eax    ; put the result into unm3 with addition process, keeping old value plus new value
                     adc [unm3 + edi * 4 + 4], edx    ; put the result into unm3 with addition process, keeping old value plus new value, with carry
                     adc [unm2 + edi * 4 + 8], 0      ; in case carry propagates store in carry holder, add in later

                     inc edi                          ; increment unm2 and unm3 position pointer
                     inc esi                          ; increment unm10 position pointer
                 .until esi >= cnr0                   ; cnr0 is the number of dd's in unm10, repeat if not done with all dd's
             .endif
             mov esi, 0                               ; reset counter
             inc ebx                                  ; increment unm0 position pointer
             mov edi, ebx                             ; save to pointer from dd grouping
         .until ebx >= cnr0                           ; cnr0 is the number of dd's in unm0, repeat if not done with all dd's
         ; -------------------------------------------------------------------------
         ;               Process carry's/borrow's that propagated over during Divide's
         ; -------------------------------------------------------------------------
         mov ecx, cnr0                                ; get the number of dd's in unm11 (good being defined as how many significant digits unm11 has)
         add ecx, cnr0                                ; add the number of dd's in unm10 - adding significant digits creates total digits for output
         xor eax, eax                                 ; reset
         xor edi, edi                                 ; set appropriate flags
         clc                                          ; not needed  carry value from bit 0 of eax, which was set to 0
         .repeat
             bt eax, 0                                ; needed to restore carry because the .until modifies it
             mov edx, [unm2 + edi * 4 ]               ; Get value from unm2[edi]
             adc [unm3 + edi * 4], edx                ; Add one more if carry was previously set and put result into unm3[edi]
             setc al                                  ; save carry for next iteration of the .repeat loop
             inc edi                                  ; increment position pointer
         .until edi >= ecx
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Divide_It endp
; 
